﻿Imports System.Drawing.Image
Imports System.Drawing.Imaging
Imports System.IO
Imports System.Text
Public Class ZoomAffiche
    Dim img3 As Image
    Dim img4 As Image
    Private Declare Auto Function SystemParametersInfo Lib "user32.dll" (ByVal uAction As Integer, ByVal uParam As Integer, ByVal lpvParam As String, ByVal fuWinIni As Integer) As Integer
    Private Sub ZoomAffiche_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        img3 = Me.BackgroundImage
        img4 = Me.BackgroundImage.Clone
        Me.AutoSize = True
        Me.ResizeRedraw = True
        'Me.BackgroundImageLayout = ImageLayout.None
        Dim PropTitre As PropertyItem = img3.GetPropertyItem(&H10E)
        Dim Titre As String = Encoding.Default.GetString(PropTitre.Value, 0, PropTitre.Len)
        Dim PropDuree As PropertyItem = img3.GetPropertyItem(&H8298)
        Dim Duree As String = Encoding.Default.GetString(PropDuree.Value, 0, PropDuree.Len)
        Dim PropVideo As PropertyItem = img3.GetPropertyItem(&H13B)
        Dim Video As String = Encoding.Default.GetString(PropVideo.Value, 0, PropVideo.Len)
        TxtTitre1.Text = Titre
        TxtTitre2.Text = Duree
        TxtTitre3.Text = Video
        Me.Text = TxtTitre1.Text & " (" & TxtTitre2.Text & ")" & " Bande-annonce: " & TxtTitre3.Text
    End Sub

    Public Shared Function Resizeit(ByVal b As Bitmap, ByVal nWidth As Integer, ByVal nHeight As Integer, ByVal bBilinear As Boolean) As Bitmap
        Dim bTemp As Bitmap = CType(b.Clone(), Bitmap)
        b = New Bitmap(nWidth, nHeight, bTemp.PixelFormat)

        Dim nXFactor As Double = CDbl(bTemp.Width) / CDbl(nWidth)
        Dim nYFactor As Double = CDbl(bTemp.Height) / CDbl(nHeight)

        If bBilinear Then
            Dim fraction_x, fraction_y, one_minus_x, one_minus_y As Double
            Dim ceil_x, ceil_y, floor_x, floor_y As Integer
            Dim c1 As New Color()
            Dim c2 As New Color()
            Dim c3 As New Color()
            Dim c4 As New Color()
            Dim red, green, blue As Byte

            Dim b1, b2 As Byte

            For x As Integer = 0 To b.Width - 1
                For y As Integer = 0 To b.Height - 1
                    ' Setup

                    floor_x = CInt(Fix(Math.Floor(x * nXFactor)))
                    floor_y = CInt(Fix(Math.Floor(y * nYFactor)))
                    ceil_x = floor_x + 1
                    If ceil_x >= bTemp.Width Then
                        ceil_x = floor_x
                    End If
                    ceil_y = floor_y + 1
                    If ceil_y >= bTemp.Height Then
                        ceil_y = floor_y
                    End If
                    fraction_x = x * nXFactor - floor_x
                    fraction_y = y * nYFactor - floor_y
                    one_minus_x = 1.0 - fraction_x
                    one_minus_y = 1.0 - fraction_y

                    c1 = bTemp.GetPixel(floor_x, floor_y)
                    c2 = bTemp.GetPixel(ceil_x, floor_y)
                    c3 = bTemp.GetPixel(floor_x, ceil_y)
                    c4 = bTemp.GetPixel(ceil_x, ceil_y)

                    ' Blue
                    b1 = CByte(one_minus_x * c1.B + fraction_x * c2.B)

                    b2 = CByte(one_minus_x * c3.B + fraction_x * c4.B)

                    blue = CByte(one_minus_y * CDbl(b1) + fraction_y * CDbl(b2))

                    ' Green
                    b1 = CByte(one_minus_x * c1.G + fraction_x * c2.G)

                    b2 = CByte(one_minus_x * c3.G + fraction_x * c4.G)

                    green = CByte(one_minus_y * CDbl(b1) + fraction_y * CDbl(b2))

                    ' Red
                    b1 = CByte(one_minus_x * c1.R + fraction_x * c2.R)

                    b2 = CByte(one_minus_x * c3.R + fraction_x * c4.R)

                    red = CByte(one_minus_y * CDbl(b1) + fraction_y * CDbl(b2))

                    b.SetPixel(x, y, System.Drawing.Color.FromArgb(255, red, green, blue))
                Next y
            Next x
        Else
            For x As Integer = 0 To b.Width - 1
                For y As Integer = 0 To b.Height - 1
                    b.SetPixel(x, y, bTemp.GetPixel(CInt(Fix(Math.Floor(x * nXFactor))), CInt(Fix(Math.Floor(y * nYFactor)))))
                Next y
            Next x
        End If

        bTemp.Dispose()
        Return b
    End Function
    Public Function GrayScale(ByVal Img As System.Drawing.Image) As System.Drawing.Image
        Dim GrayAttributes As System.Drawing.Imaging.ImageAttributes
        Dim GrayMatrix As New System.Drawing.Imaging.ColorMatrix
        GrayMatrix.Matrix00 = 1 / 3.0F
        GrayMatrix.Matrix01 = 1 / 3.0F
        GrayMatrix.Matrix02 = 1 / 3.0F
        GrayMatrix.Matrix10 = 1 / 3.0F
        GrayMatrix.Matrix11 = 1 / 3.0F
        GrayMatrix.Matrix12 = 1 / 3.0F
        GrayMatrix.Matrix20 = 1 / 3.0F
        GrayMatrix.Matrix21 = 1 / 3.0F
        GrayMatrix.Matrix22 = 1 / 3.0F
        GrayAttributes = New System.Drawing.Imaging.ImageAttributes()
        GrayAttributes.SetColorMatrix(GrayMatrix, System.Drawing.Imaging.ColorMatrixFlag.Default, System.Drawing.Imaging.ColorAdjustType.Default)
        Dim FinalImg As New System.Drawing.Bitmap(Img.Width, Img.Height)
        Dim Graphics As System.Drawing.Graphics = System.Drawing.Graphics.FromImage(FinalImg)
        Graphics.DrawImage(Img, New Rectangle(0, 0, FinalImg.Width, FinalImg.Height), 0, 0, FinalImg.Width, FinalImg.Height, System.Drawing.GraphicsUnit.Pixel, GrayAttributes)
        Return FinalImg
    End Function
    Private Sub NoirEtBlancToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NoirEtBlancToolStripMenuItem.Click
        Dim img2 As Image
        img2 = Me.BackgroundImage
        Me.BackgroundImage = GrayScale(img2)
        Me.Refresh()
        img2.Dispose()
        NoirEtBlancToolStripMenuItem.Enabled = False
        CouleurToolStripMenuItem.Enabled = True
    End Sub

    Private Sub FermerImageToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FermerImageToolStripMenuItem.Click
        img3.Dispose()
        Me.Dispose()
    End Sub

    Private Sub ToolStripMenuItem6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripMenuItem6.Click
        Dim img2 As Image
        img2 = Me.BackgroundImage
        Dim w As Int32 = img2.Width / 2
        Dim h As Int32 = img2.Height / 2
        Me.BackgroundImage = Resizeit(img2, w, h, True)
        Me.Size = Me.BackgroundImage.Size
        Me.Refresh()
        'Sizemnu.Text = "image size = " & Me.BackgroundImage.Size.ToString
        img2.Dispose()
    End Sub

    Private Sub ToolStripMenuItem5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripMenuItem5.Click
        Dim img2 As Image
        img2 = Me.BackgroundImage
        Dim w As Int32 = img2.Width / 1.5
        Dim h As Int32 = img2.Height / 1.5
        Me.BackgroundImage = Resizeit(img2, w, h, True)
        Me.Size = Me.BackgroundImage.Size
        Me.Refresh()
        'Sizemnu.Text = "image size = " & Me.BackgroundImage.Size.ToString
        img2.Dispose()
    End Sub

    Private Sub X15ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles X15ToolStripMenuItem.Click
        Dim img2 As Image
        img2 = Me.BackgroundImage
        Dim w As Int32 = img2.Width * 1.5
        Dim h As Int32 = img2.Height * 1.5
        Me.BackgroundImage = Resizeit(img2, w, h, True)
        Me.Size = Me.BackgroundImage.Size
        Me.Refresh()
        'Sizemnu.Text = "image size = " & Me.BackgroundImage.Size.ToString
        img2.Dispose()
    End Sub

    Private Sub X2ToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles X2ToolStripMenuItem1.Click
        Dim img2 As Image
        img2 = Me.BackgroundImage
        Dim w As Int32 = img2.Width * 2
        Dim h As Int32 = img2.Height * 2
        Me.BackgroundImage = Resizeit(img2, w, h, True)
        Me.Size = Me.BackgroundImage.Size
        Me.Refresh()
        'Sizemnu.Text = "image size = " & Me.BackgroundImage.Size.ToString
        img2.Dispose()
    End Sub
   
    Private Sub CouleurToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CouleurToolStripMenuItem.Click
        Me.AutoSize = True
        Me.ResizeRedraw = True
        Me.BackgroundImageLayout = ImageLayout.None
        Me.BackgroundImage = img4
        Me.Refresh()
        img4.Dispose()
    End Sub

    
End Class
