﻿Imports System.IO
Imports System.Drawing.Imaging
Imports System.Text

Public Class VisuAffiches
    Dim gpath As String
    Dim unique As Long = Now.Ticks
    Public Shared ftype As String = ".jpg.jpeg"
    Public Shared imgPaths() As String
    Dim ipath As String = "c:\affichesmodifs2"
    Dim tm As String

    Private Sub LstFill(ByVal ipath As String)

        Dim xx As Integer = 0

        Dim ist As String
        Dim i As Integer = 0
        Dim opt As System.IO.SearchOption = System.IO.SearchOption.TopDirectoryOnly
        Me.Cursor = Cursors.WaitCursor
        With lstvItem
            .BeginUpdate()
            .Clear()
        End With

        imglst.Images.Clear()

        ReDim imgPaths(0)

        For Each ist In Directory.GetFiles(ipath, "*", opt)
            If ftype.Contains(Path.GetExtension(ist)) = True Then
                ReDim Preserve imgPaths(i)
                imgPaths(i) = ist

                Select Case Path.GetExtension(ist)
                    Case Is = ".jpg", ".jpeg"
                        imglst.Images.Add(My.Resources.jpg)
                End Select

                With lstvItem
                    .Items.Add(Path.GetFileNameWithoutExtension(ist), i)
                    .Items.Item(i).SubItems.Add(ist)
                End With
                xx += 1
                i += 1
            End If
        Next
        Me.Cursor = Cursors.Arrow
        lstvItem.EndUpdate()
        Application.DoEvents()
        Try
            If Me.lstvItem.Items.Count <> 0 Then
                For i = 0 To imglst.Images.Count - 1
                    Dim img As Image = Image.FromFile(imgPaths(i))
                    Dim w As Double = img.Width / 5
                    Dim h As Double = img.Height / 5
                    imglst.Images.Item(i) = Image.FromFile(imgPaths(i)).GetThumbnailImage(w, h, Nothing, IntPtr.Zero)
                    ListBox1.Items.Add(imgPaths(i))
                    lstvItem.RedrawItems(i, i, True)
                    Application.DoEvents()
                Next
            End If

        Catch ex As Exception

        End Try

        If lstvItem.Items.Count <> 0 Then

        End If
    End Sub
    Private Sub ToolStripButton1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton1.Click
        Close()
    End Sub
    Private Sub VisuAffiches_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        LstFill(ipath)
    End Sub

    Private Sub lstvItem_MouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles lstvItem.MouseClick
        Dim s As String = lstvItem.SelectedItems(0).SubItems(1).Text
        If File.Exists(s) = True Then
            Dim img3 As Image = Image.FromFile(s)
            Dim PropTitre As PropertyItem = img3.GetPropertyItem(&H10E)
            Dim Titre As String = Encoding.Default.GetString(PropTitre.Value, 0, PropTitre.Len)
            Dim PropDuree As PropertyItem = img3.GetPropertyItem(&H8298)
            Dim Duree As String = Encoding.Default.GetString(PropDuree.Value, 0, PropDuree.Len)
            Dim PropVideo As PropertyItem = img3.GetPropertyItem(&H13B)
            Dim Video As String = Encoding.Default.GetString(PropVideo.Value, 0, PropVideo.Len)
            ToolStripTxtTitre.Text = Titre
            ToolStripDuree.Text = "- " & Duree
        End If
    End Sub

    Private Sub lstvItem_MouseDoubleClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles lstvItem.MouseDoubleClick
        Dim frm As New ZoomAffiche
        Try
            Dim s As String = lstvItem.SelectedItems(0).SubItems(1).Text

            If File.Exists(s) = True Then
                frm.BackgroundImage = Image.FromFile(s)
                frm.Width = frm.BackgroundImage.Width
                frm.Height = frm.BackgroundImage.Height + 20
                frm.TopMost = True
                frm.Show()
            End If
        Catch ex As Exception
        End Try
    End Sub
   
End Class